/* vim: set ts=4: */
/*
 * Copywrite 2004 Der Herr Hofrat
 * License GPL V2
 * Author der.herr@hofr.at
 */
/*
 * run through the task list of linux search for the passed pid and send it
 * a SIGKILL .
 */ 

#include <rtl.h>
#include <bits/signum.h>  /* signal number macros SIGHUP etc. */ 
#include <linux/kernel.h> /* printk level */
#include <linux/module.h> /* kernel version etc. */
#include <linux/sched.h>  /* task_struct */

MODULE_LICENSE("GPL v2");
MODULE_AUTHOR("Der Herr Hofrat");
MODULE_DESCRIPTION("Signal to a user-space app from a kernel module");

int pid=0; 
MODULE_PARM(pid,"i");

int 
ksignal(int pid,int signum) 
{
	struct task_struct *p;

	/* run through the task list of linux until we find our pid */
	for_each_task(p){
		if(p->pid == pid){
			printk("sending signal %d for pid %d\n",signum,(int)p->pid);
			/* don't have a sig_info struct to send along - pass 0 */
			return send_sig(signum,p,0);
		}
	}
	/* did not find the requested pid - do nothing */
	return -1;
}

int
init_module(void)
{
	/* check that we got a pid */
	if(pid == 0){
		printk("need a pid to kill\n");
		return -1;
	}
	/* send pid a SIGKILL */
	ksignal(pid,SIGKILL);
	return 0;
}

void 
cleanup_module(void) 
{
	printk("out of here\n");
}
