#include <linux/errno.h>
#include <rtl.h>
#include <time.h>
#include <semaphore.h>

#include <pthread.h>
#include <mqueue.h>

pthread_t task;
mqd_t my_queue;
mode_t my_mode;
struct mq_attr	my_attr;
struct timespec timeout;

char data1[1024];
char data2[1024];
char data3[1024];
void *thread_code(void *t)
{
	int res;

	memset(data1,'1',1024);
	memset(data2,'2',1024);
	memset(data3,'3',1024);
	while (1) {
		int ret;

		res=mq_send(my_queue,data1,100,1);
		if(res<0)
			rtl_printf("Error sending, errno: %d\n",errno);
		rtl_printf("Data has been sent\n");
		rtl_printf("A dormir...\n");
		usleep(10000000);
		rtl_printf("Despierto\n");

		res=mq_send(my_queue,data1,100,1);
		if(res<0)
			rtl_printf("Error sending\n");
		rtl_printf("Data has been sent\n");

		res=mq_send(my_queue,data1,100,1);
		if(res<0)
			rtl_printf("Error sending\n");
		rtl_printf("Data has been sent\n");

		res=mq_send(my_queue,data1,100,1);
		if(res<0)
			rtl_printf("Error sending\n");
		rtl_printf("Data has been sent\n");

		res=mq_send(my_queue,data1,100,1);
		if(res<0)
			rtl_printf("Error sending, errno: %d\n",errno);
		rtl_printf("Data has been sent\n");
		/*rtl_printf("total secs: %l\n",1000000 / NSECS_PER_SEC);
		rtl_printf("total nsecs: %l\n",(clock_gethrtime(CLOCK_REALTIME) % NSECS_PER_SEC));*/
		timeout.tv_sec=5;
		timeout.tv_nsec=1000000000;
		res=mq_timedsend(my_queue,data3,100,4,&timeout);
		if(res<0)
			rtl_printf("Error sending,errno: %d\n",errno);
		rtl_printf("Data has been sent\n");
		rtl_printf("Ok. wait_np for let other thread to use the queue\n");
		ret = pthread_wait_np();
		return 0;
	}
	return 0;
}

int init_module(void)
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;
	char queue_name[10];
	int i=0;

	my_attr.mq_maxmsg=5;
	my_attr.mq_msgsize=100;


		memset(queue_name,'\0',10);
		sprintf(queue_name,"queue%d",i);
		my_queue=mq_open(queue_name,O_CREAT|O_RDWR,my_mode,&my_attr);

		if(my_queue<0){
			rtl_printf("Error opening queue, errno: %d\n",errno);
			return -1;
		}
		rtl_printf("Queue %s is opened \n",queue_name);

	pthread_attr_init (&attr);
	sched_param.sched_priority = 4;
	pthread_attr_setschedparam (&attr, &sched_param);
	ret = pthread_create (&task,  &attr, thread_code, (void *)1);

	return 0;
}


void cleanup_module(void)
{
	pthread_cancel (task);
	pthread_join (task, NULL);
}
