#include <linux/errno.h>
#include <rtl.h>
#include <time.h>

#include <pthread.h>
#include <mqueue.h>

pthread_t task;
mqd_t my_queue;
mode_t my_mode;
struct mq_attr	my_attr;

char data[1024];


static void signal_handler(int sig){
  rtl_printf("I am a slave thread executing the handeler for signal:%d \n",sig);
  rtl_printf("Waking up!\n");
  pthread_wakeup_np(pthread_self());
}

void *thread_code(void *t)
{
	int res;
	int i;
	struct sigaction sa;
	struct sigevent se;

	sa.sa_handler=signal_handler;
	sa.sa_mask=0;
	sa.sa_flags=0;

	if ((sigaction(RTL_SIGUSR1,&sa,NULL))<0 ){
		rtl_printf("sigaction(RTL_SIGUSR1,&sa,NULL) FAILING\n");
	}

	se.sigev_notify=SIGEV_SIGNAL;
	se.sigev_signo=RTL_SIGUSR1;
	res=mq_notify(my_queue,&se);
	if(res!=0){
		rtl_printf("Error en notify\n");
	}

	pthread_wait_np();

	memset(&data,'s',1024);
	while (1) {
		/*ret = pthread_wait_np();*/

		rtl_printf("Waiting for message...\n");
		res=mq_receive(my_queue,data,100,NULL);
		if(res<0)
			rtl_printf("Error receiving\n");
		rtl_printf("Receiving %d bytes\n",res);
		for(i=0;i<100;i++)
			rtl_printf("%c",data[i]);
		rtl_printf("\n");
		return 0;
	}
	return 0;
}

/* #define DEBUG  */
int init_module(void)
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	my_queue=mq_open("queue0",O_RDONLY);

	if(my_queue<0){
		rtl_printf("Error opening queue, errno: %d\n",errno);
		return -1;
	}
	rtl_printf("Queue A opened\n");

	pthread_attr_init (&attr);
	sched_param.sched_priority = 4;
	pthread_attr_setschedparam (&attr, &sched_param);
	ret = pthread_create (&task,  &attr, thread_code, (void *)1);

	return 0;
}


void cleanup_module(void)
{
	pthread_cancel (task);
	pthread_join (task, NULL);
}
