/*
 * Taken from the examples directory of TLSF-1.3.1 and modified for 
 * RTLinux/GPL - example usage of the tlsf pool allocator.
 */
/* Author Der Herr Hofrat, der.herr@hofr.at
 * (C) 2005 OpenTech EDV Research GmbH
 * License: GPL Version 2
 */
#include <rtl.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_sync.h>
#include <pthread.h>
#include <posix/unistd.h>
#include <rtl_malloc.h>

MODULE_LICENSE("GPL v2");
MODULE_AUTHOR("der.herr@hofr.at");
MODULE_DESCRIPTION("pure posix periodic thread - using clock_nanosleep");

int *ptr[100];
int i;

#define DELAY_NS 5000000 /* 5 milliseconds */

pthread_t thread;
void *thread_code(void *);


void *thread_code(void *arg){
	struct timespec ts;
	int size=100;
	clock_gettime(CLOCK_REALTIME,&ts);

//	rtl_printf("Allocating memory objects\n");
	for (i=0; i< 100; i++){
//		rtl_printf("allocating memory object %d (size %d)\n",i,size);
		if (!(ptr[i]=rtl_malloc(size))){
			printk("rtl_malloc Error\n");
		}
		timespec_add_ns(&ts,DELAY_NS);
		clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME, &ts, NULL);
	}

//	rtl_printf("Freeing memory objects\n");
	for (i=0; i< 100; i++)
		rtl_free(ptr[i]);

	return (void *)i;
}


int init_module(void){
	if( pthread_create(&thread,NULL,thread_code,NULL))
	{
		printk("thread creation failed\n");
		return -1;
	}
	return 0;
}
   
void cleanup_module(void) {
//	printk("Termiating thread\n");
	pthread_join(thread,NULL);
}
	
