/*
 * Written by Der Herr Hofrat, der.herr@hofr.at
 * (C) 2004
 * License: GPL Version 2
 */
/*
 * some experimental cache optimizations for 686 
 */

#ifndef __RTL_CACHE_H__
#define __RTL_CACHE_H__

#ifdef CONFIG_RTL_MTRR 
#include <rtl_sync.h>
static void cache_setup(void){
	static pthread_spinlock_t rtl_cr0_lock;
        /* reset it to write back mode:
	 * 
	 * 1) disable interrupts
	 * 2) setup the MTRR registers for write back via msr
	 * 3) flush the cache (needed if we were in write-through mode 
	 *    not needed if cache was disabled)
	 * 4) set NW and CD to 0 -> write through
	 * 5) write it to cr0
	 * 6) enable interrupts again
	 */
        pthread_spin_lock (&rtl_cr0_lock);
	__asm__ __volatile__(\
		"movl $0x2FF,%%ecx\n\t" \
		"rdmsr\n\t" \
		"orl $0x800,%%eax\n\t" /* turn on MTRR again */ \
		"wrmsr\n\t" \
		"movl %%cr0,%%eax\n\t" \
		"andl $0x9fffffff,%%eax\n\t" \
		"movl %%eax,%%cr0\n\t" \
                "wbinvd\n\t" \
		:::"eax","ecx");
        pthread_spin_unlock (&rtl_cr0_lock);
}
#else
static void cache_setup(void){
}
#endif
#endif
