ifeq (../../rtl.mk,$(wildcard ../../rtl.mk))
include ../../rtl.mk
else
#You must include rtl.mk; set the path properly
#include $(PATH)/rtl.mk
endif

#---------- Directories ---------- 

RTL_LWIP_DIR:=$(shell pwd)
RTL_LWIP_SRC=$(RTL_LWIP_DIR)/src
TOOLSDIR= $(RTL_LWIP_DIR)/rtl_lwip_tools
COREDIR=$(RTL_LWIP_SRC)/core
CORE4DIR=$(RTL_LWIP_SRC)/core/ipv4
APIDIR=$(RTL_LWIP_SRC)/api
RTLDIR=$(RTL_LWIP_SRC)/arch/RTLinux
ARCHDIR=$(RTLDIR)
ARESDIR=$(RTL_LWIP_DIR)/ares-1.1.1-lwip
NETIFDIR=$(RTL_LWIP_SRC)/netif
NETDIR=$(RTLDIR)/netif
TLSFDIR=$(TOOLSDIR)/TLSFv1.1
POLICYDIR=$(NETDIR)/net_policy
DRIVERSDIR=$(NETDIR)/physif
EXAMPLESDIR=$(RTL_LWIP_DIR)/examples
SADIR=$(EXAMPLESDIR)/sequential_api
SATCPECHODIR=$(SADIR)/tcp_echo
SAUDPECHODIR=$(SADIR)/udp_echo
SATCPECHOMDIR=$(SADIR)/tcp_echo_multithread
SOCKETSDIR=$(EXAMPLESDIR)/sockets_api
DNSDIR=$(EXAMPLESDIR)/dns
HTTPDDIR=$(EXAMPLESDIR)/raw_api/http


#---------- Options ---------- 

CFLAGS = -D__KERNEL__ -Wall -Wstrict-prototypes -Wno-trigraphs -fno-strict-aliasing -fno-common -pipe -mpreferred-stack-boundary=2 -DMODULE -include $(RTLINUX_DIR)/include/linux/modversions.h -D__RTL__ -D_LOOSE_KERNEL_NAMES -O2 -I$(RTLINUX_DIR)/include -I$(RTL_DIR)/include -I$(RTL_DIR)/include/compat -I$(RTL_DIR)/include/posix
RTL_LWIPFLAGS= -I$(RTL_LWIP_SRC)/include -I$(RTLDIR)/include \
	-I$(RTL_LWIP_SRC)/include/ipv4 	-Iapps -I. -I$(TOOLSDIR) -I$(ARESDIR) \
	-I$(TLSFDIR) -Wall -DIPv4 -I$(RTL_LWIP_DIR)
CC=gcc
RTLFLAGS= $(CFLAGS)
AWKSCRIPT:=./dirdep.awk
